#pragma once
#include "AuctionUser.h"
#include <list>

namespace Example
{
   // forward declarations
   class Seller;  
   class AuctionHouse; 

   // An AuctionBrowser has an account to view online auctions, but may not
   // have registered as a Buyer, and is thus not yet setup to make purchases.
   class AuctionBrowser : public AuctionUser
   {
   public:
      AuctionBrowser(const string& username, AuctionHouse& auctioneer);
      virtual ~AuctionBrowser();

      // view a Seller's online auction offering
      virtual void lookAt(Seller& vendor, const string& what, float cost);
   };

   typedef list<AuctionBrowser*> BrowserList;
}