#pragma once

#include <map>
#include <set>
#include <string>

using namespace std;

namespace Example
{
   class AuctionUser;   // forward declaration

   // An AuctionHouse holds online auctions for registered users.
   class AuctionHouse
   {
   public:
      AuctionHouse();
      ~AuctionHouse();

      void addNewUser(AuctionUser& newUser, const string& password);

      // users can change the password stored on the AuctionHouse's servers
      void updatePassword(AuctionUser& user, const string& password);
      
      // users call this to log themselves in
      bool login(const string& username, const string& password);

      void advertise();

   private:
      map<string, string> m_passwords;  // the database of valid usernames and passwords
      set<AuctionUser*>   m_users;
   };
}