
#include "AuctionUser.h"
#include "AuctionHouse.h"
#include <iostream>

namespace Example
{
   AuctionUser::AuctionUser(const string& username, AuctionHouse& auctioneer)
   {
      m_username = username;
      m_password = "changeme!";
      auctioneer.addNewUser(*this, m_password);
      m_auctionHouse = &auctioneer;
   }

   AuctionUser::~AuctionUser()
   {
   }

   bool AuctionUser::login() const
   {
      return m_auctionHouse->login(m_username, m_password);
   }

   void AuctionUser::changePassword(const string& newPassword)
   {
      // remember the new password
      m_password = newPassword;
      // change it on the server side
      m_auctionHouse->updatePassword(*this, newPassword);
   }

   void AuctionUser::receiveEmail(const string& message)
   {
      cout << "To: " << m_username << "; Subject : " << message << endl;
      cout << endl;
   }

   const string& AuctionUser::getUsername() const
   {
      return m_username;
   }
}
