#pragma once
#include "AccountHolder.h"
#include <map>
#include <string>

using namespace std;

namespace Example
{
   // A Bank holds the accounts of AccountHolders.
   class Bank
   {
   public:
      Bank();
      ~Bank();

      void addNewAccount(AccountHolder& newCustomer, float openingBalance);

      void deposit(AccountHolder& customer, float sum);
      void withdraw(AccountHolder& customer, float sum);
      
      void sendOutStatements(const string& date);

   private:      
      typedef map<AccountHolder*, float> AccountDatabase;
      AccountDatabase m_accountBalances;    // all the current accounts, with balances
   };
}