
#include "Seller.h"
#include <sstream>

namespace Example
{
   Seller::Seller(const string& name, const string& address, AuctionHouse& auctioneer, const string& username)
      : AccountHolder(name, address)
      , AuctionUser(username, auctioneer)
   {
   }

   Seller::~Seller()
   {
   }

   void Seller::receiveEmail(const string& message)
   {
      // use the base class's implementation
      AuctionUser::receiveEmail(message);

      // and also do some recordkeeping of our own
      m_emailRecords.push_back(message);
   }

   void Seller::sell(AuctionUser& toWhom, const string& what, float howMuch)
   {
      // deposit the buyer's money before they change their mind!
      deposit(howMuch);
      ostringstream message;
      message << "I have received your payment for a " << what << " in the amount of " << howMuch;

      // let them know we've taken, er, received their money :)
      toWhom.receiveEmail(message.str());
   }

}