#pragma once
#include "AccountHolder.h"
#include "AuctionUser.h"
#include <list>

using namespace std;

namespace Example
{
   // A Seller has registered with the AuctionHouse to sell
   // products online.
   class Seller : public AccountHolder, public AuctionUser
   {
   public:
      Seller(const string& name, const string& address, 
         AuctionHouse& auctioneer, const string& username);
      virtual ~Seller();

      // buyers call this to enact a sale
      void sell(AuctionUser& toWhom, const string& what, float howMuch);

      // callback to receive emails from the AuctionHouse
      virtual void receiveEmail(const string& message);

   private:
      // Sellers keep records of all their emails
      list<string> m_emailRecords;
   };
}